> For the complete documentation index, see [llms.txt](https://developer.harness.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.harness.io/api-reference/software-delivery-agent-apis/gitops/repositories.md).

# Repositories

## ListRepositories gets a list of all configured repositories

> ListRepositories gets a list of all configured repositories.

```json
{"openapi":"3.0.0","info":{"title":"Harness NextGen GitOps API Reference","version":"1.0"},"paths":{"/api/v1/agents/{agentIdentifier}/repositories":{"get":{"summary":"ListRepositories gets a list of all configured repositories","description":"ListRepositories gets a list of all configured repositories.","operationId":"AgentRepositoryService_ListRepositories","responses":{"200":{"description":"A successful response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/repositoriesRepositoryList"}}}},"default":{"description":"An unexpected error response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/gatewayruntimeError"}}}}},"parameters":[{"name":"agentIdentifier","description":"Agent identifier for entity.","in":"path","required":true,"schema":{"type":"string"}},{"name":"accountIdentifier","description":"Account Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"orgIdentifier","description":"Organization Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"projectIdentifier","description":"Project Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"identifier","in":"query","required":false,"schema":{"type":"string"}},{"name":"query.repo","description":"Repo URL for query.","in":"query","required":false,"schema":{"type":"string"}},{"name":"query.forceRefresh","description":"Whether to force a cache refresh on repo's connection state.","in":"query","required":false,"schema":{"type":"boolean"}},{"name":"query.project","description":"The associated project project.","in":"query","required":false,"schema":{"type":"string"}}],"tags":["Repositories"]}}},"components":{"schemas":{"repositoriesRepositoryList":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/v1ListMeta"},"items":{"type":"array","items":{"$ref":"#/components/schemas/repositoriesRepository"}}},"description":"RepositoryList is a collection of Repositories."},"v1ListMeta":{"type":"object","properties":{"selfLink":{"type":"string","title":"Deprecated: selfLink is a legacy read-only field that is no longer populated by the system.\n+optional"},"resourceVersion":{"type":"string","title":"String that identifies the server's internal version of this object that\ncan be used by clients to determine when objects have changed.\nValue must be treated as opaque by clients and passed unmodified back to the server.\nPopulated by the system.\nRead-only.\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency\n+optional"},"continue":{"type":"string","description":"continue may be set if the user set a limit on the number of items returned, and indicates that\nthe server has more data available. The value is opaque and may be used to issue another request\nto the endpoint that served this list to retrieve the next set of available objects. Continuing a\nconsistent list may not be possible if the server configuration has changed or more than a few\nminutes have passed. The resourceVersion field returned when using this continue value will be\nidentical to the value in the first response, unless you have received this token from an error\nmessage."},"remainingItemCount":{"type":"string","format":"int64","title":"remainingItemCount is the number of subsequent items in the list which are not included in this\nlist response. If the list request contained label or field selectors, then the number of\nremaining items is unknown and the field will be left unset and omitted during serialization.\nIf the list is complete (either because it is not chunking or because this is the last chunk),\nthen there are no more remaining items and this field will be left unset and omitted during\nserialization.\nServers older than v1.15 do not set this field.\nThe intended use of the remainingItemCount is *estimating* the size of a collection. Clients\nshould not rely on the remainingItemCount to be set or to be exact.\n+optional"},"shardInfo":{"$ref":"#/components/schemas/v1ShardInfo"}},"description":"ListMeta describes metadata that synthetic resources must have, including lists and\nvarious status objects. A resource may have only one of {ObjectMeta, ListMeta}."},"v1ShardInfo":{"type":"object","properties":{"selector":{"type":"string","title":"selector is the shard selector string from the request, echoed back so clients\ncan verify which shard they received and merge responses from multiple shards.\n+required"}},"description":"ShardInfo describes the shard selector that was applied to produce a list response.\nIts presence on a list response indicates the list is a filtered subset."},"repositoriesRepository":{"type":"object","properties":{"repo":{"type":"string","title":"Repo contains the URL to the remote repository"},"username":{"type":"string","title":"Username contains the user name used for authenticating at the remote repository"},"password":{"type":"string","title":"Password contains the password or PAT used for authenticating at the remote repository"},"sshPrivateKey":{"type":"string","description":"SSHPrivateKey contains the PEM data for authenticating at the repo server. Only used with Git repos."},"connectionState":{"$ref":"#/components/schemas/commonsConnectionState"},"insecureIgnoreHostKey":{"type":"boolean","title":"InsecureIgnoreHostKey should not be used anymore, Insecure is favoured\nUsed only for Git repos"},"insecure":{"type":"boolean","title":"Insecure specifies whether the connection to the repository ignores any errors when verifying TLS certificates or SSH host keys"},"enableLfs":{"type":"boolean","description":"EnableLFS specifies whether git-lfs support should be enabled for this repo. Only valid for Git repositories."},"tlsClientCertData":{"type":"string","title":"TLSClientCertData contains a certificate in PEM format for authenticating at the repo server"},"tlsClientCertKey":{"type":"string","title":"TLSClientCertKey contains a private key in PEM format for authenticating at the repo server"},"type":{"type":"string","description":"Type specifies the type of the repo. Can be either \"git\" or \"helm. \"git\" is assumed if empty or absent."},"name":{"type":"string","title":"Name specifies a name to be used for this repo. Only used with Helm repos"},"inheritedCreds":{"type":"boolean","title":"Whether credentials were inherited from a credential set"},"enableOCI":{"type":"boolean","title":"EnableOCI specifies whether helm-oci support should be enabled for this repo"},"githubAppPrivateKey":{"type":"string","title":"Github App Private Key PEM data"},"githubAppID":{"type":"string","format":"int64","title":"GithubAppId specifies the ID of the GitHub app used to access the repo"},"githubAppInstallationID":{"type":"string","format":"int64","title":"GithubAppInstallationId specifies the installation ID of the GitHub App used to access the repo"},"githubAppEnterpriseBaseUrl":{"type":"string","title":"GithubAppEnterpriseBaseURL specifies the base URL of GitHub Enterprise installation. If empty will default to https://api.github.com"},"proxy":{"type":"string","title":"Proxy specifies the HTTP/HTTPS proxy used to access the repo"},"project":{"type":"string","title":"Reference between project and repository that allow you automatically to be added as item inside SourceRepos project entity"},"connectionType":{"type":"string","title":"Identifies the authentication method used to connect to the repository"},"forceHttpBasicAuth":{"type":"boolean","title":"ForceHttpBasicAuth specifies whether Argo CD should attempt to force basic auth for HTTP connections"},"noProxy":{"type":"string","title":"NoProxy specifies a list of targets where the proxy isn't used, applies only in cases where the proxy is applied"},"useAzureWorkloadIdentity":{"type":"boolean","title":"UseAzureWorkloadIdentity specifies whether to use Azure Workload Identity for authentication"},"bearerToken":{"type":"string","title":"BearerToken contains the bearer token used for Git BitBucket Data Center auth at the repo server"},"insecureOCIForceHttp":{"type":"boolean","description":"InsecureOCIForceHttp specifies whether the connection to the repository uses TLS at _all_. If true, no TLS. This flag is applicable for OCI repos only."},"depth":{"type":"string","format":"int64","description":"Depth specifies the depth for shallow clones. A value of 0 or omitting the field indicates a full clone."},"webhookManifestCacheWarmDisabled":{"type":"boolean","description":"WebhookManifestCacheWarmDisabled disables manifest cache warming during webhook processing for this repository.\nWhen set, webhook handlers will only trigger reconciliation for affected applications and skip Redis cache\noperations for unaffected ones. Recommended for large monorepos with plain YAML manifests."},"azureServicePrincipalClientId":{"type":"string","title":"AzureServicePrincipalClientId specifies the client ID of the Azure Service Principal used to access the repo"},"azureServicePrincipalClientSecret":{"type":"string","title":"AzureServicePrincipalClientSecret specifies the client secret of the Azure Service Principal used to access the repo"},"azureServicePrincipalTenantId":{"type":"string","title":"AzureServicePrincipalTenantId specifies the tenant ID of the Azure Service Principal used to access the repo"},"azureActiveDirectoryEndpoint":{"type":"string","title":"AzureActiveDirectoryEndpoint specifies the Azure Active Directory endpoint used for Service Principal authentication. If empty will default to https://login.microsoftonline.com"}},"title":"Repository is a repository holding application configurations"},"commonsConnectionState":{"type":"object","properties":{"status":{"type":"string","title":"Status contains the current status indicator for the connection"},"message":{"type":"string","title":"Message contains human readable information about the connection status"},"attemptedAt":{"$ref":"#/components/schemas/v1Time"},"attemptedAtTs":{"type":"string","format":"date-time","title":"attemptedAtTs is the google timestamp variation of attemptedAt"}},"title":"ConnectionState contains information about remote resource connection state, currently used for clusters and repositories"},"v1Time":{"type":"object","properties":{"seconds":{"type":"string","format":"int64","description":"Represents seconds of UTC time since Unix epoch\n1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to\n9999-12-31T23:59:59Z inclusive."},"nanos":{"type":"integer","format":"int32","description":"Non-negative fractions of a second at nanosecond resolution. Negative\nsecond values with fractions must still have non-negative nanos values\nthat count forward in time. Must be from 0 to 999,999,999\ninclusive. This field may be limited in precision depending on context."}},"description":"Time is a wrapper around time.Time which supports correct\nmarshaling to YAML and JSON.  Wrappers are provided for many\nof the factory methods that the time package offers.\n\n+protobuf.options.marshal=false\n+protobuf.as=Timestamp\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"gatewayruntimeError":{"type":"object","properties":{"error":{"type":"string"},"code":{"type":"integer","format":"int32"},"message":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/protobufAny"}}}},"protobufAny":{"type":"object","properties":{"type_url":{"type":"string","description":"A URL/resource name that uniquely identifies the type of the serialized\nprotocol buffer message. This string must contain at least\none \"/\" character. The last segment of the URL's path must represent\nthe fully qualified name of the type (as in\n`path/google.protobuf.Duration`). The name should be in a canonical form\n(e.g., leading \".\" is not accepted).\n\nIn practice, teams usually precompile into the binary all types that they\nexpect it to use in the context of Any. However, for URLs which use the\nscheme `http`, `https`, or no scheme, one can optionally set up a type\nserver that maps type URLs to message definitions as follows:\n\n* If no scheme is provided, `https` is assumed.\n* An HTTP GET on the URL must yield a [google.protobuf.Type][]\n  value in binary format, or produce an error.\n* Applications are allowed to cache lookup results based on the\n  URL, or have them precompiled into a binary to avoid any\n  lookup. Therefore, binary compatibility needs to be preserved\n  on changes to types. (Use versioned type names to manage\n  breaking changes.)\n\nNote: this functionality is not currently available in the official\nprotobuf release, and it is not used for type URLs beginning with\ntype.googleapis.com.\n\nSchemes other than `http`, `https` (or the empty scheme) might be\nused with implementation specific semantics."},"value":{"type":"string","format":"byte","description":"Must be a valid serialized protocol buffer of the above specified type."}},"description":"`Any` contains an arbitrary serialized protocol buffer message along with a\nURL that describes the type of the serialized message.\n\nProtobuf library provides support to pack/unpack Any values in the form\nof utility functions or additional generated methods of the Any type.\n\nExample 1: Pack and unpack a message in C++.\n\n    Foo foo = ...;\n    Any any;\n    any.PackFrom(foo);\n    ...\n    if (any.UnpackTo(&foo)) {\n      ...\n    }\n\nExample 2: Pack and unpack a message in Java.\n\n    Foo foo = ...;\n    Any any = Any.pack(foo);\n    ...\n    if (any.is(Foo.class)) {\n      foo = any.unpack(Foo.class);\n    }\n\n Example 3: Pack and unpack a message in Python.\n\n    foo = Foo(...)\n    any = Any()\n    any.Pack(foo)\n    ...\n    if any.Is(Foo.DESCRIPTOR):\n      any.Unpack(foo)\n      ...\n\n Example 4: Pack and unpack a message in Go\n\n     foo := &pb.Foo{...}\n     any, err := anypb.New(foo)\n     if err != nil {\n       ...\n     }\n     ...\n     foo := &pb.Foo{}\n     if err := any.UnmarshalTo(foo); err != nil {\n       ...\n     }\n\nThe pack methods provided by protobuf library will by default use\n'type.googleapis.com/full.type.name' as the type URL and the unpack\nmethods only use the fully qualified type name after the last '/'\nin the type URL, for example \"foo.bar.com/x/y.z\" will yield type\nname \"y.z\".\n\n\nJSON\n====\nThe JSON representation of an `Any` value uses the regular\nrepresentation of the deserialized, embedded message, with an\nadditional field `@type` which contains the type URL. Example:\n\n    package google.profile;\n    message Person {\n      string first_name = 1;\n      string last_name = 2;\n    }\n\n    {\n      \"@type\": \"type.googleapis.com/google.profile.Person\",\n      \"firstName\": <string>,\n      \"lastName\": <string>\n    }\n\nIf the embedded message type is well-known and has a custom JSON\nrepresentation, that representation will be embedded adding a field\n`value` which holds the custom JSON in addition to the `@type`\nfield. Example (for message [google.protobuf.Duration][]):\n\n    {\n      \"@type\": \"type.googleapis.com/google.protobuf.Duration\",\n      \"value\": \"1.212s\"\n    }"}}}}
```

## CreateRepository creates a new repository configuration

> CreateRepository creates a new repository configuration.

```json
{"openapi":"3.0.0","info":{"title":"Harness NextGen GitOps API Reference","version":"1.0"},"paths":{"/api/v1/agents/{agentIdentifier}/repositories":{"post":{"summary":"CreateRepository creates a new repository configuration","description":"CreateRepository creates a new repository configuration.","operationId":"AgentRepositoryService_CreateRepository","responses":{"200":{"description":"A successful response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/servicev1Repository"}}}},"default":{"description":"An unexpected error response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/gatewayruntimeError"}}}}},"parameters":[{"name":"agentIdentifier","description":"Agent identifier for entity.","in":"path","required":true,"schema":{"type":"string"}},{"name":"accountIdentifier","description":"Account Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"orgIdentifier","description":"Organization Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"projectIdentifier","description":"Project Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"identifier","in":"query","required":false,"schema":{"type":"string"}},{"name":"repoCredsId","in":"query","required":false,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/repositoriesRepoCreateRequest"}}},"required":true},"tags":["Repositories"]}}},"components":{"schemas":{"servicev1Repository":{"type":"object","properties":{"accountIdentifier":{"type":"string","description":"Account Identifier for the Entity."},"orgIdentifier":{"type":"string","description":"Organization Identifier for the Entity."},"projectIdentifier":{"type":"string","description":"Project Identifier for the Entity."},"agentIdentifier":{"type":"string","description":"Agent identifier for entity."},"identifier":{"type":"string"},"repository":{"$ref":"#/components/schemas/repositoriesRepository"},"createdAt":{"type":"string","format":"date-time"},"lastModifiedAt":{"type":"string","format":"date-time"},"stale":{"type":"boolean"},"repositoryCredentialsId":{"type":"string"},"uuid":{"type":"string","description":"Kubernetes ObjectMeta.UID of the repository Secret."},"subId":{"type":"string","description":"Sub-identifier for ConfigMap-extracted entities; empty for Repositories."},"agentUuid":{"type":"string","description":"UID of the parent agent document."}}},"repositoriesRepository":{"type":"object","properties":{"repo":{"type":"string","title":"Repo contains the URL to the remote repository"},"username":{"type":"string","title":"Username contains the user name used for authenticating at the remote repository"},"password":{"type":"string","title":"Password contains the password or PAT used for authenticating at the remote repository"},"sshPrivateKey":{"type":"string","description":"SSHPrivateKey contains the PEM data for authenticating at the repo server. Only used with Git repos."},"connectionState":{"$ref":"#/components/schemas/commonsConnectionState"},"insecureIgnoreHostKey":{"type":"boolean","title":"InsecureIgnoreHostKey should not be used anymore, Insecure is favoured\nUsed only for Git repos"},"insecure":{"type":"boolean","title":"Insecure specifies whether the connection to the repository ignores any errors when verifying TLS certificates or SSH host keys"},"enableLfs":{"type":"boolean","description":"EnableLFS specifies whether git-lfs support should be enabled for this repo. Only valid for Git repositories."},"tlsClientCertData":{"type":"string","title":"TLSClientCertData contains a certificate in PEM format for authenticating at the repo server"},"tlsClientCertKey":{"type":"string","title":"TLSClientCertKey contains a private key in PEM format for authenticating at the repo server"},"type":{"type":"string","description":"Type specifies the type of the repo. Can be either \"git\" or \"helm. \"git\" is assumed if empty or absent."},"name":{"type":"string","title":"Name specifies a name to be used for this repo. Only used with Helm repos"},"inheritedCreds":{"type":"boolean","title":"Whether credentials were inherited from a credential set"},"enableOCI":{"type":"boolean","title":"EnableOCI specifies whether helm-oci support should be enabled for this repo"},"githubAppPrivateKey":{"type":"string","title":"Github App Private Key PEM data"},"githubAppID":{"type":"string","format":"int64","title":"GithubAppId specifies the ID of the GitHub app used to access the repo"},"githubAppInstallationID":{"type":"string","format":"int64","title":"GithubAppInstallationId specifies the installation ID of the GitHub App used to access the repo"},"githubAppEnterpriseBaseUrl":{"type":"string","title":"GithubAppEnterpriseBaseURL specifies the base URL of GitHub Enterprise installation. If empty will default to https://api.github.com"},"proxy":{"type":"string","title":"Proxy specifies the HTTP/HTTPS proxy used to access the repo"},"project":{"type":"string","title":"Reference between project and repository that allow you automatically to be added as item inside SourceRepos project entity"},"connectionType":{"type":"string","title":"Identifies the authentication method used to connect to the repository"},"forceHttpBasicAuth":{"type":"boolean","title":"ForceHttpBasicAuth specifies whether Argo CD should attempt to force basic auth for HTTP connections"},"noProxy":{"type":"string","title":"NoProxy specifies a list of targets where the proxy isn't used, applies only in cases where the proxy is applied"},"useAzureWorkloadIdentity":{"type":"boolean","title":"UseAzureWorkloadIdentity specifies whether to use Azure Workload Identity for authentication"},"bearerToken":{"type":"string","title":"BearerToken contains the bearer token used for Git BitBucket Data Center auth at the repo server"},"insecureOCIForceHttp":{"type":"boolean","description":"InsecureOCIForceHttp specifies whether the connection to the repository uses TLS at _all_. If true, no TLS. This flag is applicable for OCI repos only."},"depth":{"type":"string","format":"int64","description":"Depth specifies the depth for shallow clones. A value of 0 or omitting the field indicates a full clone."},"webhookManifestCacheWarmDisabled":{"type":"boolean","description":"WebhookManifestCacheWarmDisabled disables manifest cache warming during webhook processing for this repository.\nWhen set, webhook handlers will only trigger reconciliation for affected applications and skip Redis cache\noperations for unaffected ones. Recommended for large monorepos with plain YAML manifests."},"azureServicePrincipalClientId":{"type":"string","title":"AzureServicePrincipalClientId specifies the client ID of the Azure Service Principal used to access the repo"},"azureServicePrincipalClientSecret":{"type":"string","title":"AzureServicePrincipalClientSecret specifies the client secret of the Azure Service Principal used to access the repo"},"azureServicePrincipalTenantId":{"type":"string","title":"AzureServicePrincipalTenantId specifies the tenant ID of the Azure Service Principal used to access the repo"},"azureActiveDirectoryEndpoint":{"type":"string","title":"AzureActiveDirectoryEndpoint specifies the Azure Active Directory endpoint used for Service Principal authentication. If empty will default to https://login.microsoftonline.com"}},"title":"Repository is a repository holding application configurations"},"commonsConnectionState":{"type":"object","properties":{"status":{"type":"string","title":"Status contains the current status indicator for the connection"},"message":{"type":"string","title":"Message contains human readable information about the connection status"},"attemptedAt":{"$ref":"#/components/schemas/v1Time"},"attemptedAtTs":{"type":"string","format":"date-time","title":"attemptedAtTs is the google timestamp variation of attemptedAt"}},"title":"ConnectionState contains information about remote resource connection state, currently used for clusters and repositories"},"v1Time":{"type":"object","properties":{"seconds":{"type":"string","format":"int64","description":"Represents seconds of UTC time since Unix epoch\n1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to\n9999-12-31T23:59:59Z inclusive."},"nanos":{"type":"integer","format":"int32","description":"Non-negative fractions of a second at nanosecond resolution. Negative\nsecond values with fractions must still have non-negative nanos values\nthat count forward in time. Must be from 0 to 999,999,999\ninclusive. This field may be limited in precision depending on context."}},"description":"Time is a wrapper around time.Time which supports correct\nmarshaling to YAML and JSON.  Wrappers are provided for many\nof the factory methods that the time package offers.\n\n+protobuf.options.marshal=false\n+protobuf.as=Timestamp\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"gatewayruntimeError":{"type":"object","properties":{"error":{"type":"string"},"code":{"type":"integer","format":"int32"},"message":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/protobufAny"}}}},"protobufAny":{"type":"object","properties":{"type_url":{"type":"string","description":"A URL/resource name that uniquely identifies the type of the serialized\nprotocol buffer message. This string must contain at least\none \"/\" character. The last segment of the URL's path must represent\nthe fully qualified name of the type (as in\n`path/google.protobuf.Duration`). The name should be in a canonical form\n(e.g., leading \".\" is not accepted).\n\nIn practice, teams usually precompile into the binary all types that they\nexpect it to use in the context of Any. However, for URLs which use the\nscheme `http`, `https`, or no scheme, one can optionally set up a type\nserver that maps type URLs to message definitions as follows:\n\n* If no scheme is provided, `https` is assumed.\n* An HTTP GET on the URL must yield a [google.protobuf.Type][]\n  value in binary format, or produce an error.\n* Applications are allowed to cache lookup results based on the\n  URL, or have them precompiled into a binary to avoid any\n  lookup. Therefore, binary compatibility needs to be preserved\n  on changes to types. (Use versioned type names to manage\n  breaking changes.)\n\nNote: this functionality is not currently available in the official\nprotobuf release, and it is not used for type URLs beginning with\ntype.googleapis.com.\n\nSchemes other than `http`, `https` (or the empty scheme) might be\nused with implementation specific semantics."},"value":{"type":"string","format":"byte","description":"Must be a valid serialized protocol buffer of the above specified type."}},"description":"`Any` contains an arbitrary serialized protocol buffer message along with a\nURL that describes the type of the serialized message.\n\nProtobuf library provides support to pack/unpack Any values in the form\nof utility functions or additional generated methods of the Any type.\n\nExample 1: Pack and unpack a message in C++.\n\n    Foo foo = ...;\n    Any any;\n    any.PackFrom(foo);\n    ...\n    if (any.UnpackTo(&foo)) {\n      ...\n    }\n\nExample 2: Pack and unpack a message in Java.\n\n    Foo foo = ...;\n    Any any = Any.pack(foo);\n    ...\n    if (any.is(Foo.class)) {\n      foo = any.unpack(Foo.class);\n    }\n\n Example 3: Pack and unpack a message in Python.\n\n    foo = Foo(...)\n    any = Any()\n    any.Pack(foo)\n    ...\n    if any.Is(Foo.DESCRIPTOR):\n      any.Unpack(foo)\n      ...\n\n Example 4: Pack and unpack a message in Go\n\n     foo := &pb.Foo{...}\n     any, err := anypb.New(foo)\n     if err != nil {\n       ...\n     }\n     ...\n     foo := &pb.Foo{}\n     if err := any.UnmarshalTo(foo); err != nil {\n       ...\n     }\n\nThe pack methods provided by protobuf library will by default use\n'type.googleapis.com/full.type.name' as the type URL and the unpack\nmethods only use the fully qualified type name after the last '/'\nin the type URL, for example \"foo.bar.com/x/y.z\" will yield type\nname \"y.z\".\n\n\nJSON\n====\nThe JSON representation of an `Any` value uses the regular\nrepresentation of the deserialized, embedded message, with an\nadditional field `@type` which contains the type URL. Example:\n\n    package google.profile;\n    message Person {\n      string first_name = 1;\n      string last_name = 2;\n    }\n\n    {\n      \"@type\": \"type.googleapis.com/google.profile.Person\",\n      \"firstName\": <string>,\n      \"lastName\": <string>\n    }\n\nIf the embedded message type is well-known and has a custom JSON\nrepresentation, that representation will be embedded adding a field\n`value` which holds the custom JSON in addition to the `@type`\nfield. Example (for message [google.protobuf.Duration][]):\n\n    {\n      \"@type\": \"type.googleapis.com/google.protobuf.Duration\",\n      \"value\": \"1.212s\"\n    }"},"repositoriesRepoCreateRequest":{"type":"object","properties":{"repo":{"$ref":"#/components/schemas/repositoriesRepository"},"upsert":{"type":"boolean","title":"Whether to create in upsert mode"},"credsOnly":{"type":"boolean","title":"Whether to operate on credential set instead of repository"},"genType":{"$ref":"#/components/schemas/repositoriesESOGeneratorType"},"ecrGen":{"$ref":"#/components/schemas/repositoriesECRAuthorizationTokenGenerator"},"gcrGen":{"$ref":"#/components/schemas/repositoriesGCRAccessTokenGenerator"},"refreshInterval":{"type":"string","description":"refreshInterval in format 1s, 1m, 1h..."}},"title":"RepoCreateRequest is a request for creating repository config"},"repositoriesESOGeneratorType":{"type":"string","enum":["UNSET","AWS_ECR","GOOGLE_GCR"],"default":"UNSET"},"repositoriesECRAuthorizationTokenGenerator":{"type":"object","properties":{"region":{"type":"string"},"secretRef":{"$ref":"#/components/schemas/repositoriesAWSSecretRef"},"jwtAuth":{"$ref":"#/components/schemas/repositoriesServiceAccountSelector"},"role":{"type":"string"}},"description":"ECRAuthorizationTokenSpec represents externalSecret for ECR External Secret Operator generator."},"repositoriesAWSSecretRef":{"type":"object","properties":{"awsAccessKeyID":{"type":"string"},"awsSecretAccessKey":{"type":"string"},"awsSessionToken":{"type":"string"}}},"repositoriesServiceAccountSelector":{"type":"object","properties":{"name":{"type":"string"},"namespace":{"type":"string"},"audiences":{"type":"array","items":{"type":"string"}}}},"repositoriesGCRAccessTokenGenerator":{"type":"object","properties":{"projectID":{"type":"string"},"accessKey":{"type":"string"},"workloadIdentity":{"$ref":"#/components/schemas/repositoriesGCRWorkloadIdentity"}}},"repositoriesGCRWorkloadIdentity":{"type":"object","properties":{"serviceAccountRef":{"$ref":"#/components/schemas/repositoriesServiceAccountSelector"},"clusterLocation":{"type":"string"},"clusterName":{"type":"string"},"clusterProjectID":{"type":"string"}}}}}}
```

## Checks whether External Secrets Operator is installed

> CheckExternalSecretsOperator Checks whether External Secrets Operator is installed or not

```json
{"openapi":"3.0.0","info":{"title":"Harness NextGen GitOps API Reference","version":"1.0"},"paths":{"/api/v1/agents/{agentIdentifier}/repositories/eso/check":{"get":{"summary":"Checks whether External Secrets Operator is installed","description":"CheckExternalSecretsOperator Checks whether External Secrets Operator is installed or not","operationId":"AgentRepositoryService_CheckExternalSecretsOperator","responses":{"200":{"description":"A successful response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/repositoriesCheckESOResponse"}}}},"default":{"description":"An unexpected error response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/gatewayruntimeError"}}}}},"parameters":[{"name":"agentIdentifier","description":"Agent identifier for entity.","in":"path","required":true,"schema":{"type":"string"}},{"name":"accountIdentifier","description":"Account Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"orgIdentifier","description":"Organization Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"projectIdentifier","description":"Project Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}}],"tags":["Repositories"]}}},"components":{"schemas":{"repositoriesCheckESOResponse":{"type":"object","properties":{"esoPresent":{"type":"boolean"}}},"gatewayruntimeError":{"type":"object","properties":{"error":{"type":"string"},"code":{"type":"integer","format":"int32"},"message":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/protobufAny"}}}},"protobufAny":{"type":"object","properties":{"type_url":{"type":"string","description":"A URL/resource name that uniquely identifies the type of the serialized\nprotocol buffer message. This string must contain at least\none \"/\" character. The last segment of the URL's path must represent\nthe fully qualified name of the type (as in\n`path/google.protobuf.Duration`). The name should be in a canonical form\n(e.g., leading \".\" is not accepted).\n\nIn practice, teams usually precompile into the binary all types that they\nexpect it to use in the context of Any. However, for URLs which use the\nscheme `http`, `https`, or no scheme, one can optionally set up a type\nserver that maps type URLs to message definitions as follows:\n\n* If no scheme is provided, `https` is assumed.\n* An HTTP GET on the URL must yield a [google.protobuf.Type][]\n  value in binary format, or produce an error.\n* Applications are allowed to cache lookup results based on the\n  URL, or have them precompiled into a binary to avoid any\n  lookup. Therefore, binary compatibility needs to be preserved\n  on changes to types. (Use versioned type names to manage\n  breaking changes.)\n\nNote: this functionality is not currently available in the official\nprotobuf release, and it is not used for type URLs beginning with\ntype.googleapis.com.\n\nSchemes other than `http`, `https` (or the empty scheme) might be\nused with implementation specific semantics."},"value":{"type":"string","format":"byte","description":"Must be a valid serialized protocol buffer of the above specified type."}},"description":"`Any` contains an arbitrary serialized protocol buffer message along with a\nURL that describes the type of the serialized message.\n\nProtobuf library provides support to pack/unpack Any values in the form\nof utility functions or additional generated methods of the Any type.\n\nExample 1: Pack and unpack a message in C++.\n\n    Foo foo = ...;\n    Any any;\n    any.PackFrom(foo);\n    ...\n    if (any.UnpackTo(&foo)) {\n      ...\n    }\n\nExample 2: Pack and unpack a message in Java.\n\n    Foo foo = ...;\n    Any any = Any.pack(foo);\n    ...\n    if (any.is(Foo.class)) {\n      foo = any.unpack(Foo.class);\n    }\n\n Example 3: Pack and unpack a message in Python.\n\n    foo = Foo(...)\n    any = Any()\n    any.Pack(foo)\n    ...\n    if any.Is(Foo.DESCRIPTOR):\n      any.Unpack(foo)\n      ...\n\n Example 4: Pack and unpack a message in Go\n\n     foo := &pb.Foo{...}\n     any, err := anypb.New(foo)\n     if err != nil {\n       ...\n     }\n     ...\n     foo := &pb.Foo{}\n     if err := any.UnmarshalTo(foo); err != nil {\n       ...\n     }\n\nThe pack methods provided by protobuf library will by default use\n'type.googleapis.com/full.type.name' as the type URL and the unpack\nmethods only use the fully qualified type name after the last '/'\nin the type URL, for example \"foo.bar.com/x/y.z\" will yield type\nname \"y.z\".\n\n\nJSON\n====\nThe JSON representation of an `Any` value uses the regular\nrepresentation of the deserialized, embedded message, with an\nadditional field `@type` which contains the type URL. Example:\n\n    package google.profile;\n    message Person {\n      string first_name = 1;\n      string last_name = 2;\n    }\n\n    {\n      \"@type\": \"type.googleapis.com/google.profile.Person\",\n      \"firstName\": <string>,\n      \"lastName\": <string>\n    }\n\nIf the embedded message type is well-known and has a custom JSON\nrepresentation, that representation will be embedded adding a field\n`value` which holds the custom JSON in addition to the `@type`\nfield. Example (for message [google.protobuf.Duration][]):\n\n    {\n      \"@type\": \"type.googleapis.com/google.protobuf.Duration\",\n      \"value\": \"1.212s\"\n    }"}}}}
```

## Returns a list of ESO generators installed in agent namespace.

> Returns a list of ESO generators installed in agent namespace.

```json
{"openapi":"3.0.0","info":{"title":"Harness NextGen GitOps API Reference","version":"1.0"},"paths":{"/api/v1/agents/{agentIdentifier}/repositories/eso/generators":{"get":{"summary":"Returns a list of ESO generators installed in agent namespace.","description":"Returns a list of ESO generators installed in agent namespace.","operationId":"AgentRepositoryService_ListESOGenerators","responses":{"200":{"description":"A successful response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/repositoriesESOGeneratorResponse"}}}},"default":{"description":"An unexpected error response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/gatewayruntimeError"}}}}},"parameters":[{"name":"agentIdentifier","description":"Agent identifier for entity.","in":"path","required":true,"schema":{"type":"string"}},{"name":"accountIdentifier","description":"Account Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"orgIdentifier","description":"Organization Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"projectIdentifier","description":"Project Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"type","in":"query","required":false,"schema":{"type":"string","enum":["UNSET","AWS_ECR","GOOGLE_GCR"],"default":"UNSET"}},{"name":"name","in":"query","required":false,"schema":{"type":"string"}},{"name":"url","in":"query","required":false,"schema":{"type":"string"}}],"tags":["Repositories"]}}},"components":{"schemas":{"repositoriesESOGeneratorResponse":{"type":"object","properties":{"type":{"$ref":"#/components/schemas/repositoriesESOGeneratorType"},"ecrGen":{"$ref":"#/components/schemas/repositoriesECRAuthorizationTokenGenerator"},"gcrGen":{"$ref":"#/components/schemas/repositoriesGCRAccessTokenGenerator"}}},"repositoriesESOGeneratorType":{"type":"string","enum":["UNSET","AWS_ECR","GOOGLE_GCR"],"default":"UNSET"},"repositoriesECRAuthorizationTokenGenerator":{"type":"object","properties":{"region":{"type":"string"},"secretRef":{"$ref":"#/components/schemas/repositoriesAWSSecretRef"},"jwtAuth":{"$ref":"#/components/schemas/repositoriesServiceAccountSelector"},"role":{"type":"string"}},"description":"ECRAuthorizationTokenSpec represents externalSecret for ECR External Secret Operator generator."},"repositoriesAWSSecretRef":{"type":"object","properties":{"awsAccessKeyID":{"type":"string"},"awsSecretAccessKey":{"type":"string"},"awsSessionToken":{"type":"string"}}},"repositoriesServiceAccountSelector":{"type":"object","properties":{"name":{"type":"string"},"namespace":{"type":"string"},"audiences":{"type":"array","items":{"type":"string"}}}},"repositoriesGCRAccessTokenGenerator":{"type":"object","properties":{"projectID":{"type":"string"},"accessKey":{"type":"string"},"workloadIdentity":{"$ref":"#/components/schemas/repositoriesGCRWorkloadIdentity"}}},"repositoriesGCRWorkloadIdentity":{"type":"object","properties":{"serviceAccountRef":{"$ref":"#/components/schemas/repositoriesServiceAccountSelector"},"clusterLocation":{"type":"string"},"clusterName":{"type":"string"},"clusterProjectID":{"type":"string"}}},"gatewayruntimeError":{"type":"object","properties":{"error":{"type":"string"},"code":{"type":"integer","format":"int32"},"message":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/protobufAny"}}}},"protobufAny":{"type":"object","properties":{"type_url":{"type":"string","description":"A URL/resource name that uniquely identifies the type of the serialized\nprotocol buffer message. This string must contain at least\none \"/\" character. The last segment of the URL's path must represent\nthe fully qualified name of the type (as in\n`path/google.protobuf.Duration`). The name should be in a canonical form\n(e.g., leading \".\" is not accepted).\n\nIn practice, teams usually precompile into the binary all types that they\nexpect it to use in the context of Any. However, for URLs which use the\nscheme `http`, `https`, or no scheme, one can optionally set up a type\nserver that maps type URLs to message definitions as follows:\n\n* If no scheme is provided, `https` is assumed.\n* An HTTP GET on the URL must yield a [google.protobuf.Type][]\n  value in binary format, or produce an error.\n* Applications are allowed to cache lookup results based on the\n  URL, or have them precompiled into a binary to avoid any\n  lookup. Therefore, binary compatibility needs to be preserved\n  on changes to types. (Use versioned type names to manage\n  breaking changes.)\n\nNote: this functionality is not currently available in the official\nprotobuf release, and it is not used for type URLs beginning with\ntype.googleapis.com.\n\nSchemes other than `http`, `https` (or the empty scheme) might be\nused with implementation specific semantics."},"value":{"type":"string","format":"byte","description":"Must be a valid serialized protocol buffer of the above specified type."}},"description":"`Any` contains an arbitrary serialized protocol buffer message along with a\nURL that describes the type of the serialized message.\n\nProtobuf library provides support to pack/unpack Any values in the form\nof utility functions or additional generated methods of the Any type.\n\nExample 1: Pack and unpack a message in C++.\n\n    Foo foo = ...;\n    Any any;\n    any.PackFrom(foo);\n    ...\n    if (any.UnpackTo(&foo)) {\n      ...\n    }\n\nExample 2: Pack and unpack a message in Java.\n\n    Foo foo = ...;\n    Any any = Any.pack(foo);\n    ...\n    if (any.is(Foo.class)) {\n      foo = any.unpack(Foo.class);\n    }\n\n Example 3: Pack and unpack a message in Python.\n\n    foo = Foo(...)\n    any = Any()\n    any.Pack(foo)\n    ...\n    if any.Is(Foo.DESCRIPTOR):\n      any.Unpack(foo)\n      ...\n\n Example 4: Pack and unpack a message in Go\n\n     foo := &pb.Foo{...}\n     any, err := anypb.New(foo)\n     if err != nil {\n       ...\n     }\n     ...\n     foo := &pb.Foo{}\n     if err := any.UnmarshalTo(foo); err != nil {\n       ...\n     }\n\nThe pack methods provided by protobuf library will by default use\n'type.googleapis.com/full.type.name' as the type URL and the unpack\nmethods only use the fully qualified type name after the last '/'\nin the type URL, for example \"foo.bar.com/x/y.z\" will yield type\nname \"y.z\".\n\n\nJSON\n====\nThe JSON representation of an `Any` value uses the regular\nrepresentation of the deserialized, embedded message, with an\nadditional field `@type` which contains the type URL. Example:\n\n    package google.profile;\n    message Person {\n      string first_name = 1;\n      string last_name = 2;\n    }\n\n    {\n      \"@type\": \"type.googleapis.com/google.profile.Person\",\n      \"firstName\": <string>,\n      \"lastName\": <string>\n    }\n\nIf the embedded message type is well-known and has a custom JSON\nrepresentation, that representation will be embedded adding a field\n`value` which holds the custom JSON in addition to the `@type`\nfield. Example (for message [google.protobuf.Duration][]):\n\n    {\n      \"@type\": \"type.googleapis.com/google.protobuf.Duration\",\n      \"value\": \"1.212s\"\n    }"}}}}
```

## Returns the Repository type of OCI repo

> CheckOCIRepoType Returns the Repository type of OCI repo

```json
{"openapi":"3.0.0","info":{"title":"Harness NextGen GitOps API Reference","version":"1.0"},"paths":{"/api/v1/agents/{agentIdentifier}/repositories/oci/type":{"post":{"summary":"Returns the Repository type of OCI repo","description":"CheckOCIRepoType Returns the Repository type of OCI repo","operationId":"AgentRepositoryService_CheckOCIRepoType","responses":{"200":{"description":"A successful response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/v1OCIRepoTypeResponse"}}}},"default":{"description":"An unexpected error response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/gatewayruntimeError"}}}}},"parameters":[{"name":"agentIdentifier","description":"Agent identifier for entity.","in":"path","required":true,"schema":{"type":"string"}},{"name":"accountIdentifier","description":"Account Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"orgIdentifier","description":"Organization Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"projectIdentifier","description":"Project Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/v1OCIRepoType"}}},"required":true},"tags":["Repositories"]}}},"components":{"schemas":{"v1OCIRepoTypeResponse":{"type":"object","properties":{"ociRepoType":{"$ref":"#/components/schemas/OCIRepoTypeResponseOCIRepoTypeEnum"}}},"OCIRepoTypeResponseOCIRepoTypeEnum":{"type":"string","enum":["UNSET","AWS","GOOGLE","GITHUB","DOCKERHUB"],"default":"UNSET"},"gatewayruntimeError":{"type":"object","properties":{"error":{"type":"string"},"code":{"type":"integer","format":"int32"},"message":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/protobufAny"}}}},"protobufAny":{"type":"object","properties":{"type_url":{"type":"string","description":"A URL/resource name that uniquely identifies the type of the serialized\nprotocol buffer message. This string must contain at least\none \"/\" character. The last segment of the URL's path must represent\nthe fully qualified name of the type (as in\n`path/google.protobuf.Duration`). The name should be in a canonical form\n(e.g., leading \".\" is not accepted).\n\nIn practice, teams usually precompile into the binary all types that they\nexpect it to use in the context of Any. However, for URLs which use the\nscheme `http`, `https`, or no scheme, one can optionally set up a type\nserver that maps type URLs to message definitions as follows:\n\n* If no scheme is provided, `https` is assumed.\n* An HTTP GET on the URL must yield a [google.protobuf.Type][]\n  value in binary format, or produce an error.\n* Applications are allowed to cache lookup results based on the\n  URL, or have them precompiled into a binary to avoid any\n  lookup. Therefore, binary compatibility needs to be preserved\n  on changes to types. (Use versioned type names to manage\n  breaking changes.)\n\nNote: this functionality is not currently available in the official\nprotobuf release, and it is not used for type URLs beginning with\ntype.googleapis.com.\n\nSchemes other than `http`, `https` (or the empty scheme) might be\nused with implementation specific semantics."},"value":{"type":"string","format":"byte","description":"Must be a valid serialized protocol buffer of the above specified type."}},"description":"`Any` contains an arbitrary serialized protocol buffer message along with a\nURL that describes the type of the serialized message.\n\nProtobuf library provides support to pack/unpack Any values in the form\nof utility functions or additional generated methods of the Any type.\n\nExample 1: Pack and unpack a message in C++.\n\n    Foo foo = ...;\n    Any any;\n    any.PackFrom(foo);\n    ...\n    if (any.UnpackTo(&foo)) {\n      ...\n    }\n\nExample 2: Pack and unpack a message in Java.\n\n    Foo foo = ...;\n    Any any = Any.pack(foo);\n    ...\n    if (any.is(Foo.class)) {\n      foo = any.unpack(Foo.class);\n    }\n\n Example 3: Pack and unpack a message in Python.\n\n    foo = Foo(...)\n    any = Any()\n    any.Pack(foo)\n    ...\n    if any.Is(Foo.DESCRIPTOR):\n      any.Unpack(foo)\n      ...\n\n Example 4: Pack and unpack a message in Go\n\n     foo := &pb.Foo{...}\n     any, err := anypb.New(foo)\n     if err != nil {\n       ...\n     }\n     ...\n     foo := &pb.Foo{}\n     if err := any.UnmarshalTo(foo); err != nil {\n       ...\n     }\n\nThe pack methods provided by protobuf library will by default use\n'type.googleapis.com/full.type.name' as the type URL and the unpack\nmethods only use the fully qualified type name after the last '/'\nin the type URL, for example \"foo.bar.com/x/y.z\" will yield type\nname \"y.z\".\n\n\nJSON\n====\nThe JSON representation of an `Any` value uses the regular\nrepresentation of the deserialized, embedded message, with an\nadditional field `@type` which contains the type URL. Example:\n\n    package google.profile;\n    message Person {\n      string first_name = 1;\n      string last_name = 2;\n    }\n\n    {\n      \"@type\": \"type.googleapis.com/google.profile.Person\",\n      \"firstName\": <string>,\n      \"lastName\": <string>\n    }\n\nIf the embedded message type is well-known and has a custom JSON\nrepresentation, that representation will be embedded adding a field\n`value` which holds the custom JSON in addition to the `@type`\nfield. Example (for message [google.protobuf.Duration][]):\n\n    {\n      \"@type\": \"type.googleapis.com/google.protobuf.Duration\",\n      \"value\": \"1.212s\"\n    }"},"v1OCIRepoType":{"type":"object","properties":{"repoURL":{"type":"string","description":"OCI Repository URL."}}}}}}
```

## ValidateAccess gets connection state for a repository

> ValidateAccess gets connection state for a repository.

```json
{"openapi":"3.0.0","info":{"title":"Harness NextGen GitOps API Reference","version":"1.0"},"paths":{"/api/v1/agents/{agentIdentifier}/repositories/validate":{"post":{"summary":"ValidateAccess gets connection state for a repository","description":"ValidateAccess gets connection state for a repository.","operationId":"AgentRepositoryService_ValidateAccess","responses":{"200":{"description":"A successful response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/commonsConnectionState"}}}},"default":{"description":"An unexpected error response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/gatewayruntimeError"}}}}},"parameters":[{"name":"agentIdentifier","description":"Agent identifier for entity.","in":"path","required":true,"schema":{"type":"string"}},{"name":"accountIdentifier","description":"Account Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"orgIdentifier","description":"Organization Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"projectIdentifier","description":"Project Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"identifier","in":"query","required":false,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/repositoriesRepoAccessQuery"}}},"required":true},"tags":["Repositories"]}}},"components":{"schemas":{"commonsConnectionState":{"type":"object","properties":{"status":{"type":"string","title":"Status contains the current status indicator for the connection"},"message":{"type":"string","title":"Message contains human readable information about the connection status"},"attemptedAt":{"$ref":"#/components/schemas/v1Time"},"attemptedAtTs":{"type":"string","format":"date-time","title":"attemptedAtTs is the google timestamp variation of attemptedAt"}},"title":"ConnectionState contains information about remote resource connection state, currently used for clusters and repositories"},"v1Time":{"type":"object","properties":{"seconds":{"type":"string","format":"int64","description":"Represents seconds of UTC time since Unix epoch\n1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to\n9999-12-31T23:59:59Z inclusive."},"nanos":{"type":"integer","format":"int32","description":"Non-negative fractions of a second at nanosecond resolution. Negative\nsecond values with fractions must still have non-negative nanos values\nthat count forward in time. Must be from 0 to 999,999,999\ninclusive. This field may be limited in precision depending on context."}},"description":"Time is a wrapper around time.Time which supports correct\nmarshaling to YAML and JSON.  Wrappers are provided for many\nof the factory methods that the time package offers.\n\n+protobuf.options.marshal=false\n+protobuf.as=Timestamp\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"gatewayruntimeError":{"type":"object","properties":{"error":{"type":"string"},"code":{"type":"integer","format":"int32"},"message":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/protobufAny"}}}},"protobufAny":{"type":"object","properties":{"type_url":{"type":"string","description":"A URL/resource name that uniquely identifies the type of the serialized\nprotocol buffer message. This string must contain at least\none \"/\" character. The last segment of the URL's path must represent\nthe fully qualified name of the type (as in\n`path/google.protobuf.Duration`). The name should be in a canonical form\n(e.g., leading \".\" is not accepted).\n\nIn practice, teams usually precompile into the binary all types that they\nexpect it to use in the context of Any. However, for URLs which use the\nscheme `http`, `https`, or no scheme, one can optionally set up a type\nserver that maps type URLs to message definitions as follows:\n\n* If no scheme is provided, `https` is assumed.\n* An HTTP GET on the URL must yield a [google.protobuf.Type][]\n  value in binary format, or produce an error.\n* Applications are allowed to cache lookup results based on the\n  URL, or have them precompiled into a binary to avoid any\n  lookup. Therefore, binary compatibility needs to be preserved\n  on changes to types. (Use versioned type names to manage\n  breaking changes.)\n\nNote: this functionality is not currently available in the official\nprotobuf release, and it is not used for type URLs beginning with\ntype.googleapis.com.\n\nSchemes other than `http`, `https` (or the empty scheme) might be\nused with implementation specific semantics."},"value":{"type":"string","format":"byte","description":"Must be a valid serialized protocol buffer of the above specified type."}},"description":"`Any` contains an arbitrary serialized protocol buffer message along with a\nURL that describes the type of the serialized message.\n\nProtobuf library provides support to pack/unpack Any values in the form\nof utility functions or additional generated methods of the Any type.\n\nExample 1: Pack and unpack a message in C++.\n\n    Foo foo = ...;\n    Any any;\n    any.PackFrom(foo);\n    ...\n    if (any.UnpackTo(&foo)) {\n      ...\n    }\n\nExample 2: Pack and unpack a message in Java.\n\n    Foo foo = ...;\n    Any any = Any.pack(foo);\n    ...\n    if (any.is(Foo.class)) {\n      foo = any.unpack(Foo.class);\n    }\n\n Example 3: Pack and unpack a message in Python.\n\n    foo = Foo(...)\n    any = Any()\n    any.Pack(foo)\n    ...\n    if any.Is(Foo.DESCRIPTOR):\n      any.Unpack(foo)\n      ...\n\n Example 4: Pack and unpack a message in Go\n\n     foo := &pb.Foo{...}\n     any, err := anypb.New(foo)\n     if err != nil {\n       ...\n     }\n     ...\n     foo := &pb.Foo{}\n     if err := any.UnmarshalTo(foo); err != nil {\n       ...\n     }\n\nThe pack methods provided by protobuf library will by default use\n'type.googleapis.com/full.type.name' as the type URL and the unpack\nmethods only use the fully qualified type name after the last '/'\nin the type URL, for example \"foo.bar.com/x/y.z\" will yield type\nname \"y.z\".\n\n\nJSON\n====\nThe JSON representation of an `Any` value uses the regular\nrepresentation of the deserialized, embedded message, with an\nadditional field `@type` which contains the type URL. Example:\n\n    package google.profile;\n    message Person {\n      string first_name = 1;\n      string last_name = 2;\n    }\n\n    {\n      \"@type\": \"type.googleapis.com/google.profile.Person\",\n      \"firstName\": <string>,\n      \"lastName\": <string>\n    }\n\nIf the embedded message type is well-known and has a custom JSON\nrepresentation, that representation will be embedded adding a field\n`value` which holds the custom JSON in addition to the `@type`\nfield. Example (for message [google.protobuf.Duration][]):\n\n    {\n      \"@type\": \"type.googleapis.com/google.protobuf.Duration\",\n      \"value\": \"1.212s\"\n    }"},"repositoriesRepoAccessQuery":{"type":"object","properties":{"repo":{"type":"string","title":"The URL to the repo"},"username":{"type":"string","title":"Username for accessing repo"},"password":{"type":"string","title":"Password for accessing repo"},"sshPrivateKey":{"type":"string","title":"Private key data for accessing SSH repository"},"insecure":{"type":"boolean","title":"Whether to skip certificate or host key validation"},"tlsClientCertData":{"type":"string","title":"TLS client cert data for accessing HTTPS repository"},"tlsClientCertKey":{"type":"string","title":"TLS client cert key for accessing HTTPS repository"},"type":{"type":"string","title":"The type of the repo"},"name":{"type":"string","title":"The name of the repo"},"enableOci":{"type":"boolean","title":"Whether helm-oci support should be enabled for this repo"},"githubAppPrivateKey":{"type":"string","title":"Github App Private Key PEM data"},"githubAppID":{"type":"string","format":"int64","title":"Github App ID of the app used to access the repo"},"githubAppInstallationID":{"type":"string","format":"int64","title":"Github App Installation ID of the installed GitHub App"},"githubAppEnterpriseBaseUrl":{"type":"string","title":"Github App Enterprise base url if empty will default to https://api.github.com"},"proxy":{"type":"string","title":"HTTP/HTTPS proxy to access the repository"},"project":{"type":"string","title":"Reference between project and repository that allow you automatically to be added as item inside SourceRepos project entity"},"connectionType":{"type":"string","title":"Connection type of the repository"},"updateMask":{"$ref":"#/components/schemas/protobufFieldMask"}},"title":"RepoAccessQuery is a query for checking access to a repo"},"protobufFieldMask":{"type":"object","properties":{"paths":{"type":"array","items":{"type":"string"},"description":"The set of field mask paths."}},"description":"paths: \"f.a\"\n    paths: \"f.b.d\"\n\nHere `f` represents a field in some root message, `a` and `b`\nfields in the message found in `f`, and `d` a field found in the\nmessage in `f.b`.\n\nField masks are used to specify a subset of fields that should be\nreturned by a get operation or modified by an update operation.\nField masks also have a custom JSON encoding (see below).\n\n# Field Masks in Projections\n\nWhen used in the context of a projection, a response message or\nsub-message is filtered by the API to only contain those fields as\nspecified in the mask. For example, if the mask in the previous\nexample is applied to a response message as follows:\n\n    f {\n      a : 22\n      b {\n        d : 1\n        x : 2\n      }\n      y : 13\n    }\n    z: 8\n\nThe result will not contain specific values for fields x,y and z\n(their value will be set to the default, and omitted in proto text\noutput):\n\n\n    f {\n      a : 22\n      b {\n        d : 1\n      }\n    }\n\nA repeated field is not allowed except at the last position of a\npaths string.\n\nIf a FieldMask object is not present in a get operation, the\noperation applies to all fields (as if a FieldMask of all fields\nhad been specified).\n\nNote that a field mask does not necessarily apply to the\ntop-level response message. In case of a REST get operation, the\nfield mask applies directly to the response, but in case of a REST\nlist operation, the mask instead applies to each individual message\nin the returned resource list. In case of a REST custom method,\nother definitions may be used. Where the mask applies will be\nclearly documented together with its declaration in the API.  In\nany case, the effect on the returned resource/resources is required\nbehavior for APIs.\n\n# Field Masks in Update Operations\n\nA field mask in update operations specifies which fields of the\ntargeted resource are going to be updated. The API is required\nto only change the values of the fields as specified in the mask\nand leave the others untouched. If a resource is passed in to\ndescribe the updated values, the API ignores the values of all\nfields not covered by the mask.\n\nIf a repeated field is specified for an update operation, new values will\nbe appended to the existing repeated field in the target resource. Note that\na repeated field is only allowed in the last position of a `paths` string.\n\nIf a sub-message is specified in the last position of the field mask for an\nupdate operation, then new value will be merged into the existing sub-message\nin the target resource.\n\nFor example, given the target message:\n\n    f {\n      b {\n        d: 1\n        x: 2\n      }\n      c: [1]\n    }\n\nAnd an update message:\n\n    f {\n      b {\n        d: 10\n      }\n      c: [2]\n    }\n\nthen if the field mask is:\n\n paths: [\"f.b\", \"f.c\"]\n\nthen the result will be:\n\n    f {\n      b {\n        d: 10\n        x: 2\n      }\n      c: [1, 2]\n    }\n\nAn implementation may provide options to override this default behavior for\nrepeated and message fields.\n\nIn order to reset a field's value to the default, the field must\nbe in the mask and set to the default value in the provided resource.\nHence, in order to reset all fields of a resource, provide a default\ninstance of the resource and set all fields in the mask, or do\nnot provide a mask as described below.\n\nIf a field mask is not present on update, the operation applies to\nall fields (as if a field mask of all fields has been specified).\nNote that in the presence of schema evolution, this may mean that\nfields the client does not know and has therefore not filled into\nthe request will be reset to their default. If this is unwanted\nbehavior, a specific service may require a client to always specify\na field mask, producing an error if not.\n\nAs with get operations, the location of the resource which\ndescribes the updated values in the request message depends on the\noperation kind. In any case, the effect of the field mask is\nrequired to be honored by the API.\n\n## Considerations for HTTP REST\n\nThe HTTP kind of an update operation which uses a field mask must\nbe set to PATCH instead of PUT in order to satisfy HTTP semantics\n(PUT must only be used for full updates).\n\n# JSON Encoding of Field Masks\n\nIn JSON, a field mask is encoded as a single string where paths are\nseparated by a comma. Fields name in each path are converted\nto/from lower-camel naming conventions.\n\nAs an example, consider the following message declarations:\n\n    message Profile {\n      User user = 1;\n      Photo photo = 2;\n    }\n    message User {\n      string display_name = 1;\n      string address = 2;\n    }\n\nIn proto a field mask for `Profile` may look as such:\n\n    mask {\n      paths: \"user.display_name\"\n      paths: \"photo\"\n    }\n\nIn JSON, the same mask is represented as below:\n\n    {\n      mask: \"user.displayName,photo\"\n    }\n\n# Field Masks and Oneof Fields\n\nField masks treat fields in oneofs just as regular fields. Consider the\nfollowing message:\n\n    message SampleMessage {\n      oneof test_oneof {\n        string name = 4;\n        SubMessage sub_message = 9;\n      }\n    }\n\nThe field mask can be:\n\n    mask {\n      paths: \"name\"\n    }\n\nOr:\n\n    mask {\n      paths: \"sub_message\"\n    }\n\nNote that oneof type names (\"test_oneof\" in this case) cannot be used in\npaths.\n\n## Field Mask Verification\n\nThe implementation of any API method which has a FieldMask type field in the\nrequest should verify the included field paths, and return an\n`INVALID_ARGUMENT` error if any path is unmappable.","title":"`FieldMask` represents a set of symbolic field paths, for example:"}}}}
```

## Get returns a repository or its credentials

> Get returns a repository or its credentials.

```json
{"openapi":"3.0.0","info":{"title":"Harness NextGen GitOps API Reference","version":"1.0"},"paths":{"/api/v1/agents/{agentIdentifier}/repositories/{identifier}":{"get":{"summary":"Get returns a repository or its credentials","description":"Get returns a repository or its credentials.","operationId":"AgentRepositoryService_Get","responses":{"200":{"description":"A successful response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/servicev1Repository"}}}},"default":{"description":"An unexpected error response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/gatewayruntimeError"}}}}},"parameters":[{"name":"agentIdentifier","description":"Agent identifier for entity.","in":"path","required":true,"schema":{"type":"string"}},{"name":"identifier","in":"path","required":true,"schema":{"type":"string"}},{"name":"accountIdentifier","description":"Account Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"orgIdentifier","description":"Organization Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"projectIdentifier","description":"Project Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"query.repo","description":"Repo URL for query.","in":"query","required":false,"schema":{"type":"string"}},{"name":"query.forceRefresh","description":"Whether to force a cache refresh on repo's connection state.","in":"query","required":false,"schema":{"type":"boolean"}},{"name":"query.project","description":"The associated project project.","in":"query","required":false,"schema":{"type":"string"}}],"tags":["Repositories"]}}},"components":{"schemas":{"servicev1Repository":{"type":"object","properties":{"accountIdentifier":{"type":"string","description":"Account Identifier for the Entity."},"orgIdentifier":{"type":"string","description":"Organization Identifier for the Entity."},"projectIdentifier":{"type":"string","description":"Project Identifier for the Entity."},"agentIdentifier":{"type":"string","description":"Agent identifier for entity."},"identifier":{"type":"string"},"repository":{"$ref":"#/components/schemas/repositoriesRepository"},"createdAt":{"type":"string","format":"date-time"},"lastModifiedAt":{"type":"string","format":"date-time"},"stale":{"type":"boolean"},"repositoryCredentialsId":{"type":"string"},"uuid":{"type":"string","description":"Kubernetes ObjectMeta.UID of the repository Secret."},"subId":{"type":"string","description":"Sub-identifier for ConfigMap-extracted entities; empty for Repositories."},"agentUuid":{"type":"string","description":"UID of the parent agent document."}}},"repositoriesRepository":{"type":"object","properties":{"repo":{"type":"string","title":"Repo contains the URL to the remote repository"},"username":{"type":"string","title":"Username contains the user name used for authenticating at the remote repository"},"password":{"type":"string","title":"Password contains the password or PAT used for authenticating at the remote repository"},"sshPrivateKey":{"type":"string","description":"SSHPrivateKey contains the PEM data for authenticating at the repo server. Only used with Git repos."},"connectionState":{"$ref":"#/components/schemas/commonsConnectionState"},"insecureIgnoreHostKey":{"type":"boolean","title":"InsecureIgnoreHostKey should not be used anymore, Insecure is favoured\nUsed only for Git repos"},"insecure":{"type":"boolean","title":"Insecure specifies whether the connection to the repository ignores any errors when verifying TLS certificates or SSH host keys"},"enableLfs":{"type":"boolean","description":"EnableLFS specifies whether git-lfs support should be enabled for this repo. Only valid for Git repositories."},"tlsClientCertData":{"type":"string","title":"TLSClientCertData contains a certificate in PEM format for authenticating at the repo server"},"tlsClientCertKey":{"type":"string","title":"TLSClientCertKey contains a private key in PEM format for authenticating at the repo server"},"type":{"type":"string","description":"Type specifies the type of the repo. Can be either \"git\" or \"helm. \"git\" is assumed if empty or absent."},"name":{"type":"string","title":"Name specifies a name to be used for this repo. Only used with Helm repos"},"inheritedCreds":{"type":"boolean","title":"Whether credentials were inherited from a credential set"},"enableOCI":{"type":"boolean","title":"EnableOCI specifies whether helm-oci support should be enabled for this repo"},"githubAppPrivateKey":{"type":"string","title":"Github App Private Key PEM data"},"githubAppID":{"type":"string","format":"int64","title":"GithubAppId specifies the ID of the GitHub app used to access the repo"},"githubAppInstallationID":{"type":"string","format":"int64","title":"GithubAppInstallationId specifies the installation ID of the GitHub App used to access the repo"},"githubAppEnterpriseBaseUrl":{"type":"string","title":"GithubAppEnterpriseBaseURL specifies the base URL of GitHub Enterprise installation. If empty will default to https://api.github.com"},"proxy":{"type":"string","title":"Proxy specifies the HTTP/HTTPS proxy used to access the repo"},"project":{"type":"string","title":"Reference between project and repository that allow you automatically to be added as item inside SourceRepos project entity"},"connectionType":{"type":"string","title":"Identifies the authentication method used to connect to the repository"},"forceHttpBasicAuth":{"type":"boolean","title":"ForceHttpBasicAuth specifies whether Argo CD should attempt to force basic auth for HTTP connections"},"noProxy":{"type":"string","title":"NoProxy specifies a list of targets where the proxy isn't used, applies only in cases where the proxy is applied"},"useAzureWorkloadIdentity":{"type":"boolean","title":"UseAzureWorkloadIdentity specifies whether to use Azure Workload Identity for authentication"},"bearerToken":{"type":"string","title":"BearerToken contains the bearer token used for Git BitBucket Data Center auth at the repo server"},"insecureOCIForceHttp":{"type":"boolean","description":"InsecureOCIForceHttp specifies whether the connection to the repository uses TLS at _all_. If true, no TLS. This flag is applicable for OCI repos only."},"depth":{"type":"string","format":"int64","description":"Depth specifies the depth for shallow clones. A value of 0 or omitting the field indicates a full clone."},"webhookManifestCacheWarmDisabled":{"type":"boolean","description":"WebhookManifestCacheWarmDisabled disables manifest cache warming during webhook processing for this repository.\nWhen set, webhook handlers will only trigger reconciliation for affected applications and skip Redis cache\noperations for unaffected ones. Recommended for large monorepos with plain YAML manifests."},"azureServicePrincipalClientId":{"type":"string","title":"AzureServicePrincipalClientId specifies the client ID of the Azure Service Principal used to access the repo"},"azureServicePrincipalClientSecret":{"type":"string","title":"AzureServicePrincipalClientSecret specifies the client secret of the Azure Service Principal used to access the repo"},"azureServicePrincipalTenantId":{"type":"string","title":"AzureServicePrincipalTenantId specifies the tenant ID of the Azure Service Principal used to access the repo"},"azureActiveDirectoryEndpoint":{"type":"string","title":"AzureActiveDirectoryEndpoint specifies the Azure Active Directory endpoint used for Service Principal authentication. If empty will default to https://login.microsoftonline.com"}},"title":"Repository is a repository holding application configurations"},"commonsConnectionState":{"type":"object","properties":{"status":{"type":"string","title":"Status contains the current status indicator for the connection"},"message":{"type":"string","title":"Message contains human readable information about the connection status"},"attemptedAt":{"$ref":"#/components/schemas/v1Time"},"attemptedAtTs":{"type":"string","format":"date-time","title":"attemptedAtTs is the google timestamp variation of attemptedAt"}},"title":"ConnectionState contains information about remote resource connection state, currently used for clusters and repositories"},"v1Time":{"type":"object","properties":{"seconds":{"type":"string","format":"int64","description":"Represents seconds of UTC time since Unix epoch\n1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to\n9999-12-31T23:59:59Z inclusive."},"nanos":{"type":"integer","format":"int32","description":"Non-negative fractions of a second at nanosecond resolution. Negative\nsecond values with fractions must still have non-negative nanos values\nthat count forward in time. Must be from 0 to 999,999,999\ninclusive. This field may be limited in precision depending on context."}},"description":"Time is a wrapper around time.Time which supports correct\nmarshaling to YAML and JSON.  Wrappers are provided for many\nof the factory methods that the time package offers.\n\n+protobuf.options.marshal=false\n+protobuf.as=Timestamp\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"gatewayruntimeError":{"type":"object","properties":{"error":{"type":"string"},"code":{"type":"integer","format":"int32"},"message":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/protobufAny"}}}},"protobufAny":{"type":"object","properties":{"type_url":{"type":"string","description":"A URL/resource name that uniquely identifies the type of the serialized\nprotocol buffer message. This string must contain at least\none \"/\" character. The last segment of the URL's path must represent\nthe fully qualified name of the type (as in\n`path/google.protobuf.Duration`). The name should be in a canonical form\n(e.g., leading \".\" is not accepted).\n\nIn practice, teams usually precompile into the binary all types that they\nexpect it to use in the context of Any. However, for URLs which use the\nscheme `http`, `https`, or no scheme, one can optionally set up a type\nserver that maps type URLs to message definitions as follows:\n\n* If no scheme is provided, `https` is assumed.\n* An HTTP GET on the URL must yield a [google.protobuf.Type][]\n  value in binary format, or produce an error.\n* Applications are allowed to cache lookup results based on the\n  URL, or have them precompiled into a binary to avoid any\n  lookup. Therefore, binary compatibility needs to be preserved\n  on changes to types. (Use versioned type names to manage\n  breaking changes.)\n\nNote: this functionality is not currently available in the official\nprotobuf release, and it is not used for type URLs beginning with\ntype.googleapis.com.\n\nSchemes other than `http`, `https` (or the empty scheme) might be\nused with implementation specific semantics."},"value":{"type":"string","format":"byte","description":"Must be a valid serialized protocol buffer of the above specified type."}},"description":"`Any` contains an arbitrary serialized protocol buffer message along with a\nURL that describes the type of the serialized message.\n\nProtobuf library provides support to pack/unpack Any values in the form\nof utility functions or additional generated methods of the Any type.\n\nExample 1: Pack and unpack a message in C++.\n\n    Foo foo = ...;\n    Any any;\n    any.PackFrom(foo);\n    ...\n    if (any.UnpackTo(&foo)) {\n      ...\n    }\n\nExample 2: Pack and unpack a message in Java.\n\n    Foo foo = ...;\n    Any any = Any.pack(foo);\n    ...\n    if (any.is(Foo.class)) {\n      foo = any.unpack(Foo.class);\n    }\n\n Example 3: Pack and unpack a message in Python.\n\n    foo = Foo(...)\n    any = Any()\n    any.Pack(foo)\n    ...\n    if any.Is(Foo.DESCRIPTOR):\n      any.Unpack(foo)\n      ...\n\n Example 4: Pack and unpack a message in Go\n\n     foo := &pb.Foo{...}\n     any, err := anypb.New(foo)\n     if err != nil {\n       ...\n     }\n     ...\n     foo := &pb.Foo{}\n     if err := any.UnmarshalTo(foo); err != nil {\n       ...\n     }\n\nThe pack methods provided by protobuf library will by default use\n'type.googleapis.com/full.type.name' as the type URL and the unpack\nmethods only use the fully qualified type name after the last '/'\nin the type URL, for example \"foo.bar.com/x/y.z\" will yield type\nname \"y.z\".\n\n\nJSON\n====\nThe JSON representation of an `Any` value uses the regular\nrepresentation of the deserialized, embedded message, with an\nadditional field `@type` which contains the type URL. Example:\n\n    package google.profile;\n    message Person {\n      string first_name = 1;\n      string last_name = 2;\n    }\n\n    {\n      \"@type\": \"type.googleapis.com/google.profile.Person\",\n      \"firstName\": <string>,\n      \"lastName\": <string>\n    }\n\nIf the embedded message type is well-known and has a custom JSON\nrepresentation, that representation will be embedded adding a field\n`value` which holds the custom JSON in addition to the `@type`\nfield. Example (for message [google.protobuf.Duration][]):\n\n    {\n      \"@type\": \"type.googleapis.com/google.protobuf.Duration\",\n      \"value\": \"1.212s\"\n    }"}}}}
```

## UpdateRepository updates a repository configuration

> UpdateRepository updates a repository configuration.

```json
{"openapi":"3.0.0","info":{"title":"Harness NextGen GitOps API Reference","version":"1.0"},"paths":{"/api/v1/agents/{agentIdentifier}/repositories/{identifier}":{"put":{"summary":"UpdateRepository updates a repository configuration","description":"UpdateRepository updates a repository configuration.","operationId":"AgentRepositoryService_UpdateRepository","responses":{"200":{"description":"A successful response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/servicev1Repository"}}}},"default":{"description":"An unexpected error response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/gatewayruntimeError"}}}}},"parameters":[{"name":"agentIdentifier","description":"Agent identifier for entity.","in":"path","required":true,"schema":{"type":"string"}},{"name":"identifier","in":"path","required":true,"schema":{"type":"string"}},{"name":"accountIdentifier","description":"Account Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"orgIdentifier","description":"Organization Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"projectIdentifier","description":"Project Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/repositoriesRepoUpdateRequest"}}},"required":true},"tags":["Repositories"]}}},"components":{"schemas":{"servicev1Repository":{"type":"object","properties":{"accountIdentifier":{"type":"string","description":"Account Identifier for the Entity."},"orgIdentifier":{"type":"string","description":"Organization Identifier for the Entity."},"projectIdentifier":{"type":"string","description":"Project Identifier for the Entity."},"agentIdentifier":{"type":"string","description":"Agent identifier for entity."},"identifier":{"type":"string"},"repository":{"$ref":"#/components/schemas/repositoriesRepository"},"createdAt":{"type":"string","format":"date-time"},"lastModifiedAt":{"type":"string","format":"date-time"},"stale":{"type":"boolean"},"repositoryCredentialsId":{"type":"string"},"uuid":{"type":"string","description":"Kubernetes ObjectMeta.UID of the repository Secret."},"subId":{"type":"string","description":"Sub-identifier for ConfigMap-extracted entities; empty for Repositories."},"agentUuid":{"type":"string","description":"UID of the parent agent document."}}},"repositoriesRepository":{"type":"object","properties":{"repo":{"type":"string","title":"Repo contains the URL to the remote repository"},"username":{"type":"string","title":"Username contains the user name used for authenticating at the remote repository"},"password":{"type":"string","title":"Password contains the password or PAT used for authenticating at the remote repository"},"sshPrivateKey":{"type":"string","description":"SSHPrivateKey contains the PEM data for authenticating at the repo server. Only used with Git repos."},"connectionState":{"$ref":"#/components/schemas/commonsConnectionState"},"insecureIgnoreHostKey":{"type":"boolean","title":"InsecureIgnoreHostKey should not be used anymore, Insecure is favoured\nUsed only for Git repos"},"insecure":{"type":"boolean","title":"Insecure specifies whether the connection to the repository ignores any errors when verifying TLS certificates or SSH host keys"},"enableLfs":{"type":"boolean","description":"EnableLFS specifies whether git-lfs support should be enabled for this repo. Only valid for Git repositories."},"tlsClientCertData":{"type":"string","title":"TLSClientCertData contains a certificate in PEM format for authenticating at the repo server"},"tlsClientCertKey":{"type":"string","title":"TLSClientCertKey contains a private key in PEM format for authenticating at the repo server"},"type":{"type":"string","description":"Type specifies the type of the repo. Can be either \"git\" or \"helm. \"git\" is assumed if empty or absent."},"name":{"type":"string","title":"Name specifies a name to be used for this repo. Only used with Helm repos"},"inheritedCreds":{"type":"boolean","title":"Whether credentials were inherited from a credential set"},"enableOCI":{"type":"boolean","title":"EnableOCI specifies whether helm-oci support should be enabled for this repo"},"githubAppPrivateKey":{"type":"string","title":"Github App Private Key PEM data"},"githubAppID":{"type":"string","format":"int64","title":"GithubAppId specifies the ID of the GitHub app used to access the repo"},"githubAppInstallationID":{"type":"string","format":"int64","title":"GithubAppInstallationId specifies the installation ID of the GitHub App used to access the repo"},"githubAppEnterpriseBaseUrl":{"type":"string","title":"GithubAppEnterpriseBaseURL specifies the base URL of GitHub Enterprise installation. If empty will default to https://api.github.com"},"proxy":{"type":"string","title":"Proxy specifies the HTTP/HTTPS proxy used to access the repo"},"project":{"type":"string","title":"Reference between project and repository that allow you automatically to be added as item inside SourceRepos project entity"},"connectionType":{"type":"string","title":"Identifies the authentication method used to connect to the repository"},"forceHttpBasicAuth":{"type":"boolean","title":"ForceHttpBasicAuth specifies whether Argo CD should attempt to force basic auth for HTTP connections"},"noProxy":{"type":"string","title":"NoProxy specifies a list of targets where the proxy isn't used, applies only in cases where the proxy is applied"},"useAzureWorkloadIdentity":{"type":"boolean","title":"UseAzureWorkloadIdentity specifies whether to use Azure Workload Identity for authentication"},"bearerToken":{"type":"string","title":"BearerToken contains the bearer token used for Git BitBucket Data Center auth at the repo server"},"insecureOCIForceHttp":{"type":"boolean","description":"InsecureOCIForceHttp specifies whether the connection to the repository uses TLS at _all_. If true, no TLS. This flag is applicable for OCI repos only."},"depth":{"type":"string","format":"int64","description":"Depth specifies the depth for shallow clones. A value of 0 or omitting the field indicates a full clone."},"webhookManifestCacheWarmDisabled":{"type":"boolean","description":"WebhookManifestCacheWarmDisabled disables manifest cache warming during webhook processing for this repository.\nWhen set, webhook handlers will only trigger reconciliation for affected applications and skip Redis cache\noperations for unaffected ones. Recommended for large monorepos with plain YAML manifests."},"azureServicePrincipalClientId":{"type":"string","title":"AzureServicePrincipalClientId specifies the client ID of the Azure Service Principal used to access the repo"},"azureServicePrincipalClientSecret":{"type":"string","title":"AzureServicePrincipalClientSecret specifies the client secret of the Azure Service Principal used to access the repo"},"azureServicePrincipalTenantId":{"type":"string","title":"AzureServicePrincipalTenantId specifies the tenant ID of the Azure Service Principal used to access the repo"},"azureActiveDirectoryEndpoint":{"type":"string","title":"AzureActiveDirectoryEndpoint specifies the Azure Active Directory endpoint used for Service Principal authentication. If empty will default to https://login.microsoftonline.com"}},"title":"Repository is a repository holding application configurations"},"commonsConnectionState":{"type":"object","properties":{"status":{"type":"string","title":"Status contains the current status indicator for the connection"},"message":{"type":"string","title":"Message contains human readable information about the connection status"},"attemptedAt":{"$ref":"#/components/schemas/v1Time"},"attemptedAtTs":{"type":"string","format":"date-time","title":"attemptedAtTs is the google timestamp variation of attemptedAt"}},"title":"ConnectionState contains information about remote resource connection state, currently used for clusters and repositories"},"v1Time":{"type":"object","properties":{"seconds":{"type":"string","format":"int64","description":"Represents seconds of UTC time since Unix epoch\n1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to\n9999-12-31T23:59:59Z inclusive."},"nanos":{"type":"integer","format":"int32","description":"Non-negative fractions of a second at nanosecond resolution. Negative\nsecond values with fractions must still have non-negative nanos values\nthat count forward in time. Must be from 0 to 999,999,999\ninclusive. This field may be limited in precision depending on context."}},"description":"Time is a wrapper around time.Time which supports correct\nmarshaling to YAML and JSON.  Wrappers are provided for many\nof the factory methods that the time package offers.\n\n+protobuf.options.marshal=false\n+protobuf.as=Timestamp\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"gatewayruntimeError":{"type":"object","properties":{"error":{"type":"string"},"code":{"type":"integer","format":"int32"},"message":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/protobufAny"}}}},"protobufAny":{"type":"object","properties":{"type_url":{"type":"string","description":"A URL/resource name that uniquely identifies the type of the serialized\nprotocol buffer message. This string must contain at least\none \"/\" character. The last segment of the URL's path must represent\nthe fully qualified name of the type (as in\n`path/google.protobuf.Duration`). The name should be in a canonical form\n(e.g., leading \".\" is not accepted).\n\nIn practice, teams usually precompile into the binary all types that they\nexpect it to use in the context of Any. However, for URLs which use the\nscheme `http`, `https`, or no scheme, one can optionally set up a type\nserver that maps type URLs to message definitions as follows:\n\n* If no scheme is provided, `https` is assumed.\n* An HTTP GET on the URL must yield a [google.protobuf.Type][]\n  value in binary format, or produce an error.\n* Applications are allowed to cache lookup results based on the\n  URL, or have them precompiled into a binary to avoid any\n  lookup. Therefore, binary compatibility needs to be preserved\n  on changes to types. (Use versioned type names to manage\n  breaking changes.)\n\nNote: this functionality is not currently available in the official\nprotobuf release, and it is not used for type URLs beginning with\ntype.googleapis.com.\n\nSchemes other than `http`, `https` (or the empty scheme) might be\nused with implementation specific semantics."},"value":{"type":"string","format":"byte","description":"Must be a valid serialized protocol buffer of the above specified type."}},"description":"`Any` contains an arbitrary serialized protocol buffer message along with a\nURL that describes the type of the serialized message.\n\nProtobuf library provides support to pack/unpack Any values in the form\nof utility functions or additional generated methods of the Any type.\n\nExample 1: Pack and unpack a message in C++.\n\n    Foo foo = ...;\n    Any any;\n    any.PackFrom(foo);\n    ...\n    if (any.UnpackTo(&foo)) {\n      ...\n    }\n\nExample 2: Pack and unpack a message in Java.\n\n    Foo foo = ...;\n    Any any = Any.pack(foo);\n    ...\n    if (any.is(Foo.class)) {\n      foo = any.unpack(Foo.class);\n    }\n\n Example 3: Pack and unpack a message in Python.\n\n    foo = Foo(...)\n    any = Any()\n    any.Pack(foo)\n    ...\n    if any.Is(Foo.DESCRIPTOR):\n      any.Unpack(foo)\n      ...\n\n Example 4: Pack and unpack a message in Go\n\n     foo := &pb.Foo{...}\n     any, err := anypb.New(foo)\n     if err != nil {\n       ...\n     }\n     ...\n     foo := &pb.Foo{}\n     if err := any.UnmarshalTo(foo); err != nil {\n       ...\n     }\n\nThe pack methods provided by protobuf library will by default use\n'type.googleapis.com/full.type.name' as the type URL and the unpack\nmethods only use the fully qualified type name after the last '/'\nin the type URL, for example \"foo.bar.com/x/y.z\" will yield type\nname \"y.z\".\n\n\nJSON\n====\nThe JSON representation of an `Any` value uses the regular\nrepresentation of the deserialized, embedded message, with an\nadditional field `@type` which contains the type URL. Example:\n\n    package google.profile;\n    message Person {\n      string first_name = 1;\n      string last_name = 2;\n    }\n\n    {\n      \"@type\": \"type.googleapis.com/google.profile.Person\",\n      \"firstName\": <string>,\n      \"lastName\": <string>\n    }\n\nIf the embedded message type is well-known and has a custom JSON\nrepresentation, that representation will be embedded adding a field\n`value` which holds the custom JSON in addition to the `@type`\nfield. Example (for message [google.protobuf.Duration][]):\n\n    {\n      \"@type\": \"type.googleapis.com/google.protobuf.Duration\",\n      \"value\": \"1.212s\"\n    }"},"repositoriesRepoUpdateRequest":{"type":"object","properties":{"repo":{"$ref":"#/components/schemas/repositoriesRepository"},"updateMask":{"$ref":"#/components/schemas/protobufFieldMask"},"genType":{"$ref":"#/components/schemas/repositoriesESOGeneratorType"},"ecrGen":{"$ref":"#/components/schemas/repositoriesECRAuthorizationTokenGenerator"},"gcrGen":{"$ref":"#/components/schemas/repositoriesGCRAccessTokenGenerator"},"refreshInterval":{"type":"string","description":"refreshInterval in format 1s, 1m, 1h..."}}},"protobufFieldMask":{"type":"object","properties":{"paths":{"type":"array","items":{"type":"string"},"description":"The set of field mask paths."}},"description":"paths: \"f.a\"\n    paths: \"f.b.d\"\n\nHere `f` represents a field in some root message, `a` and `b`\nfields in the message found in `f`, and `d` a field found in the\nmessage in `f.b`.\n\nField masks are used to specify a subset of fields that should be\nreturned by a get operation or modified by an update operation.\nField masks also have a custom JSON encoding (see below).\n\n# Field Masks in Projections\n\nWhen used in the context of a projection, a response message or\nsub-message is filtered by the API to only contain those fields as\nspecified in the mask. For example, if the mask in the previous\nexample is applied to a response message as follows:\n\n    f {\n      a : 22\n      b {\n        d : 1\n        x : 2\n      }\n      y : 13\n    }\n    z: 8\n\nThe result will not contain specific values for fields x,y and z\n(their value will be set to the default, and omitted in proto text\noutput):\n\n\n    f {\n      a : 22\n      b {\n        d : 1\n      }\n    }\n\nA repeated field is not allowed except at the last position of a\npaths string.\n\nIf a FieldMask object is not present in a get operation, the\noperation applies to all fields (as if a FieldMask of all fields\nhad been specified).\n\nNote that a field mask does not necessarily apply to the\ntop-level response message. In case of a REST get operation, the\nfield mask applies directly to the response, but in case of a REST\nlist operation, the mask instead applies to each individual message\nin the returned resource list. In case of a REST custom method,\nother definitions may be used. Where the mask applies will be\nclearly documented together with its declaration in the API.  In\nany case, the effect on the returned resource/resources is required\nbehavior for APIs.\n\n# Field Masks in Update Operations\n\nA field mask in update operations specifies which fields of the\ntargeted resource are going to be updated. The API is required\nto only change the values of the fields as specified in the mask\nand leave the others untouched. If a resource is passed in to\ndescribe the updated values, the API ignores the values of all\nfields not covered by the mask.\n\nIf a repeated field is specified for an update operation, new values will\nbe appended to the existing repeated field in the target resource. Note that\na repeated field is only allowed in the last position of a `paths` string.\n\nIf a sub-message is specified in the last position of the field mask for an\nupdate operation, then new value will be merged into the existing sub-message\nin the target resource.\n\nFor example, given the target message:\n\n    f {\n      b {\n        d: 1\n        x: 2\n      }\n      c: [1]\n    }\n\nAnd an update message:\n\n    f {\n      b {\n        d: 10\n      }\n      c: [2]\n    }\n\nthen if the field mask is:\n\n paths: [\"f.b\", \"f.c\"]\n\nthen the result will be:\n\n    f {\n      b {\n        d: 10\n        x: 2\n      }\n      c: [1, 2]\n    }\n\nAn implementation may provide options to override this default behavior for\nrepeated and message fields.\n\nIn order to reset a field's value to the default, the field must\nbe in the mask and set to the default value in the provided resource.\nHence, in order to reset all fields of a resource, provide a default\ninstance of the resource and set all fields in the mask, or do\nnot provide a mask as described below.\n\nIf a field mask is not present on update, the operation applies to\nall fields (as if a field mask of all fields has been specified).\nNote that in the presence of schema evolution, this may mean that\nfields the client does not know and has therefore not filled into\nthe request will be reset to their default. If this is unwanted\nbehavior, a specific service may require a client to always specify\na field mask, producing an error if not.\n\nAs with get operations, the location of the resource which\ndescribes the updated values in the request message depends on the\noperation kind. In any case, the effect of the field mask is\nrequired to be honored by the API.\n\n## Considerations for HTTP REST\n\nThe HTTP kind of an update operation which uses a field mask must\nbe set to PATCH instead of PUT in order to satisfy HTTP semantics\n(PUT must only be used for full updates).\n\n# JSON Encoding of Field Masks\n\nIn JSON, a field mask is encoded as a single string where paths are\nseparated by a comma. Fields name in each path are converted\nto/from lower-camel naming conventions.\n\nAs an example, consider the following message declarations:\n\n    message Profile {\n      User user = 1;\n      Photo photo = 2;\n    }\n    message User {\n      string display_name = 1;\n      string address = 2;\n    }\n\nIn proto a field mask for `Profile` may look as such:\n\n    mask {\n      paths: \"user.display_name\"\n      paths: \"photo\"\n    }\n\nIn JSON, the same mask is represented as below:\n\n    {\n      mask: \"user.displayName,photo\"\n    }\n\n# Field Masks and Oneof Fields\n\nField masks treat fields in oneofs just as regular fields. Consider the\nfollowing message:\n\n    message SampleMessage {\n      oneof test_oneof {\n        string name = 4;\n        SubMessage sub_message = 9;\n      }\n    }\n\nThe field mask can be:\n\n    mask {\n      paths: \"name\"\n    }\n\nOr:\n\n    mask {\n      paths: \"sub_message\"\n    }\n\nNote that oneof type names (\"test_oneof\" in this case) cannot be used in\npaths.\n\n## Field Mask Verification\n\nThe implementation of any API method which has a FieldMask type field in the\nrequest should verify the included field paths, and return an\n`INVALID_ARGUMENT` error if any path is unmappable.","title":"`FieldMask` represents a set of symbolic field paths, for example:"},"repositoriesESOGeneratorType":{"type":"string","enum":["UNSET","AWS_ECR","GOOGLE_GCR"],"default":"UNSET"},"repositoriesECRAuthorizationTokenGenerator":{"type":"object","properties":{"region":{"type":"string"},"secretRef":{"$ref":"#/components/schemas/repositoriesAWSSecretRef"},"jwtAuth":{"$ref":"#/components/schemas/repositoriesServiceAccountSelector"},"role":{"type":"string"}},"description":"ECRAuthorizationTokenSpec represents externalSecret for ECR External Secret Operator generator."},"repositoriesAWSSecretRef":{"type":"object","properties":{"awsAccessKeyID":{"type":"string"},"awsSecretAccessKey":{"type":"string"},"awsSessionToken":{"type":"string"}}},"repositoriesServiceAccountSelector":{"type":"object","properties":{"name":{"type":"string"},"namespace":{"type":"string"},"audiences":{"type":"array","items":{"type":"string"}}}},"repositoriesGCRAccessTokenGenerator":{"type":"object","properties":{"projectID":{"type":"string"},"accessKey":{"type":"string"},"workloadIdentity":{"$ref":"#/components/schemas/repositoriesGCRWorkloadIdentity"}}},"repositoriesGCRWorkloadIdentity":{"type":"object","properties":{"serviceAccountRef":{"$ref":"#/components/schemas/repositoriesServiceAccountSelector"},"clusterLocation":{"type":"string"},"clusterName":{"type":"string"},"clusterProjectID":{"type":"string"}}}}}}
```

## DeleteRepository deletes a repository from the configuration

> DeleteRepository deletes a repository from the configuration.

```json
[...]
